OGRE: Ogre::InstancedGeometry::MaterialBucket Class Reference - OGRE Documentation

Public Types | Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes

# Ogre::InstancedGeometry::MaterialBucket Class Reference

A MaterialBucket is a collection of smaller buckets with the same Material (and implicitly the same LOD). More...

`#include <OgreInstancedGeometry.h>`

Inheritance diagram for Ogre::InstancedGeometry::MaterialBucket:
[legend]

List of all members.

## Public Types
typedef vector< GeometryBucket * > ::type | GeometryBucketList
| list of Geometry Buckets in this BatchInstance
typedef VectorIterator < GeometryBucketList > | GeometryIterator
| Iterator over geometry.
## Public Member Functions
| MaterialBucket (LODBucket *parent, const String &materialName)
virtual | ~MaterialBucket ()
LODBucket * | getParent (void)
const String & | getMaterialName (void) const
| Get the material name.
void | assign (QueuedGeometry *qsm)
| Assign geometry to this bucket.
void | build ()
| Build.
void | addRenderables (RenderQueue *queue, uint8 group, Real lodValue)
| Add children to the render queue.
const MaterialPtr & | getMaterial (void) const
| Get the material for this bucket.
GeometryIterator | getGeometryIterator (void)
| Get an iterator over the contained geometry.
Technique * | getCurrentTechnique (void) const
| Get the current Technique.
void | dump (std::ofstream &of) const
| Dump contents for diagnostics.
MaterialBucket::CurrentGeometryMap * | getMaterialBucketMap (void) const
| Return the geometry map.
MaterialBucket::GeometryBucketList * | getGeometryBucketList (void) const
| Return the geometry list.
void | updateContainers (GeometryBucket *bucket, const String &format)
| fill in the map and the list
void | setLastIndex (int index)
int | getLastIndex ()
void | setMaterial (const String &name)
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Types
typedef map< String, GeometryBucket * >::type | CurrentGeometryMap
## Protected Member Functions
String | getGeometryFormatString (SubMeshLodGeometryLink *geom)
| Get a packed string identifying the geometry format.
## Protected Attributes
LODBucket * | mParent
| Pointer to parent LODBucket.
String | mMaterialName
| Material being used.
MaterialPtr | mMaterial
| Pointer to material being used.
Technique * | mTechnique
| Active technique.
int | mLastIndex
GeometryBucketList | mGeometryBucketList
| list of Geometry Buckets in this BatchInstance
CurrentGeometryMap | mCurrentGeometryMap

## Detailed Description

A MaterialBucket is a collection of smaller buckets with the same Material (and implicitly the same LOD).

Definition at line 313 of file OgreInstancedGeometry.h.

## Member Typedef Documentation

typedef map<String, GeometryBucket*>::type Ogre::InstancedGeometry::MaterialBucket::CurrentGeometryMap`[protected]`

Definition at line 331 of file OgreInstancedGeometry.h.

typedef vector<GeometryBucket*>::type Ogre::InstancedGeometry::MaterialBucket::GeometryBucketList

list of Geometry Buckets in this BatchInstance

Definition at line 317 of file OgreInstancedGeometry.h.

typedef VectorIterator<GeometryBucketList> Ogre::InstancedGeometry::MaterialBucket::GeometryIterator

Iterator over geometry.

Definition at line 352 of file OgreInstancedGeometry.h.

## Constructor & Destructor Documentation

Ogre::InstancedGeometry::MaterialBucket::MaterialBucket | ( | LODBucket * | parent,
|  | const String & | materialName |
| ) |  |  |

virtual Ogre::InstancedGeometry::MaterialBucket::~MaterialBucket | ( |  | ) | `[virtual]`

## Member Function Documentation

void Ogre::InstancedGeometry::MaterialBucket::addRenderables | ( | RenderQueue * | queue,
|  | uint8 | group,
|  | Real | lodValue |
| ) |  |  |

Add children to the render queue.

void Ogre::InstancedGeometry::MaterialBucket::assign | ( | QueuedGeometry * | qsm | ) |

Assign geometry to this bucket.

void Ogre::InstancedGeometry::MaterialBucket::build | ( |  | ) |

Build.

void Ogre::InstancedGeometry::MaterialBucket::dump | ( | std::ofstream & | of | ) | const

Dump contents for diagnostics.

Technique* Ogre::InstancedGeometry::MaterialBucket::getCurrentTechnique | ( | void |  | ) | const

Get the current Technique.

Definition at line 356 of file OgreInstancedGeometry.h.

MaterialBucket::GeometryBucketList* Ogre::InstancedGeometry::MaterialBucket::getGeometryBucketList | ( | void |  | ) | const

Return the geometry list.

String Ogre::InstancedGeometry::MaterialBucket::getGeometryFormatString | ( | SubMeshLodGeometryLink * | geom | ) | `[protected]`

Get a packed string identifying the geometry format.

GeometryIterator Ogre::InstancedGeometry::MaterialBucket::getGeometryIterator | ( | void |  | ) |

Get an iterator over the contained geometry.

int Ogre::InstancedGeometry::MaterialBucket::getLastIndex | ( |  | ) |

Definition at line 366 of file OgreInstancedGeometry.h.

const MaterialPtr& Ogre::InstancedGeometry::MaterialBucket::getMaterial | ( | void |  | ) | const

Get the material for this bucket.

Definition at line 350 of file OgreInstancedGeometry.h.

MaterialBucket::CurrentGeometryMap* Ogre::InstancedGeometry::MaterialBucket::getMaterialBucketMap | ( | void |  | ) | const

Return the geometry map.

const String& Ogre::InstancedGeometry::MaterialBucket::getMaterialName | ( | void |  | ) | const

Get the material name.

Definition at line 341 of file OgreInstancedGeometry.h.

LODBucket* Ogre::InstancedGeometry::MaterialBucket::getParent | ( | void |  | ) |

Definition at line 339 of file OgreInstancedGeometry.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

void Ogre::InstancedGeometry::MaterialBucket::setLastIndex | ( | int | index | ) |

Definition at line 365 of file OgreInstancedGeometry.h.

void Ogre::InstancedGeometry::MaterialBucket::setMaterial | ( | const String & | name | ) |

void Ogre::InstancedGeometry::MaterialBucket::updateContainers | ( | GeometryBucket * | bucket,
|  | const String & | format |
| ) |  |  |

fill in the map and the list

void Ogre::InstancedGeometry::MaterialBucket::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables |
| ) |  |  |

## Member Data Documentation

CurrentGeometryMap Ogre::InstancedGeometry::MaterialBucket::mCurrentGeometryMap`[protected]`

Definition at line 332 of file OgreInstancedGeometry.h.

GeometryBucketList Ogre::InstancedGeometry::MaterialBucket::mGeometryBucketList`[protected]`

list of Geometry Buckets in this BatchInstance

Definition at line 329 of file OgreInstancedGeometry.h.

int Ogre::InstancedGeometry::MaterialBucket::mLastIndex`[protected]`

Definition at line 327 of file OgreInstancedGeometry.h.

MaterialPtr Ogre::InstancedGeometry::MaterialBucket::mMaterial`[protected]`

Pointer to material being used.

Definition at line 324 of file OgreInstancedGeometry.h.

String Ogre::InstancedGeometry::MaterialBucket::mMaterialName`[protected]`

Material being used.

Definition at line 322 of file OgreInstancedGeometry.h.

LODBucket* Ogre::InstancedGeometry::MaterialBucket::mParent`[protected]`

Pointer to parent LODBucket.

Definition at line 320 of file OgreInstancedGeometry.h.

Technique* Ogre::InstancedGeometry::MaterialBucket::mTechnique`[protected]`

Active technique.

Definition at line 326 of file OgreInstancedGeometry.h.

The documentation for this class was generated from the following file:

- OgreInstancedGeometry.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:56